﻿using System;
using System.Threading;
using System.Windows;
using System.Windows.Threading;

namespace NwWPFDispatcherInvokeAsync {
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window {
		private const string FORMAT = "{0:00}:{1:00}:{2:00}.{3:0}";
		public MainWindow() {
			InitializeComponent();
		}
		protected override void OnSourceInitialized(EventArgs e) {
			base.OnSourceInitialized(e);
			Dispatcher.InvokeAsync(MonitorDateTimeNow, DispatcherPriority.Background);
		}
		private void MonitorDateTimeNow() {
			Thread.Sleep(1);
			var now = DateTime.Now;
			Title = string.Format(FORMAT, now.Hour, now.Minute, now.Second, now.Microsecond / 100);
			Dispatcher.InvokeAsync(MonitorDateTimeNow, DispatcherPriority.Background);
		}
	}
}